# dtlsdec

This element decodes DTLS packets. Before 1.28 the default X509 PEM certificate was encoded using a RSA 2048 bits private key. Since 1.28 the default certificate is encoded using a ECDSA P-256 private key.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──dtlsdec

## Factory details

Authors: – Patrik Oldsberg patrik.oldsberg@ericsson.com

Classification: – `Decoder/Network/DTLS`

Rank – none

Plugin – dtls

Package – GStreamer Bad Plug-ins

## Pad Templates

### `sink`

    application/x-dtls:

Presence – always

Direction – sink

Object type – GstPad

### `src`

    ANY

Presence – request

Direction – src

Object type – GstPad

## Signals

### on-key-received

    on_key_received_callback (GstElement * param_0,
                              gpointer udata)

    def on_key_received_callback (param_0, udata):
        #python callback for the 'on-key-received' signal

    function on_key_received_callback(param_0: GstElement * param_0, udata: gpointer udata): {
        // javascript callback for the 'on-key-received' signal
    }

Parameters:

`param_0` –
No description available
`udata` –
No description available

Flags: Run Last

## Properties

### connection-id

    “connection-id” gchararray

Every encoder/decoder pair should have the same, unique, connection-id

Flags : Read / Write

Default value : NULL

### connection-state

    “connection-state” GstDtlsConnectionState *

Current connection state

Flags : Read

Default value : closed (1)

### decoder-key

    “decoder-key” GstCaps *

SRTP key that should be used by the decoder

Flags : Read

### peer-pem

    “peer-pem” gchararray

The X509 certificate received in the DTLS handshake, in PEM format

Flags : Read

Default value : NULL

### pem

    “pem” gchararray

A string containing a X509 certificate and private key in PEM format

Flags : Read / Write

Default value : NULL

### srtp-auth

    “srtp-auth” guint

The SRTP authentication selected in the DTLS handshake. The value will be set to an GstDtlsSrtpAuth.

Flags : Read

Default value : 0

### srtp-cipher

    “srtp-cipher” guint

The SRTP cipher selected in the DTLS handshake. The value will be set to an GstDtlsSrtpCipher.

Flags : Read

Default value : 0

The results of the search are